package cerebral.controls;

import java.awt.event.MouseEvent;
import java.util.Map;

import javax.swing.ToolTipManager;

import prefuse.Display;
import prefuse.controls.ControlAdapter;
import prefuse.visual.EdgeItem;
import prefuse.visual.VisualItem;
import cerebral.Cerebral;
import cytoscape.Cytoscape;
import cytoscape.data.CyAttributesUtils;

public class EdgeToolTip extends ControlAdapter {

    Cerebral cerebral;

    Map tipMap;

    public EdgeToolTip(Cerebral cerebral, String attribute) {
        tipMap = CyAttributesUtils.getAttribute(attribute, Cytoscape
                .getEdgeAttributes());
        this.cerebral = cerebral;
        ToolTipManager.sharedInstance().setInitialDelay(0);

    }

    public void itemEntered(VisualItem item, MouseEvent e) {
        if (tipMap != null) {
            if (item instanceof EdgeItem) {
                Display d = (Display) e.getSource();
                String cytoId = cerebral.getCytoscapeEdge(item).getIdentifier();
                d.setToolTipText((String) tipMap.get(cytoId));
            }
        }
    }

    public void itemExited(VisualItem item, MouseEvent e) {
        if (tipMap != null) {
            if (item instanceof EdgeItem) {
                Display d = (Display) e.getSource();
                d.setToolTipText(null);
            }
        }
    }
}
