package cerebral.parallelCoordinates.cluster;

import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.swing.SwingUtilities;

import prefuse.Visualization;
import prefuse.controls.ControlAdapter;
import prefuse.visual.VisualItem;
import cerebral.parallelCoordinates.ParallelCoordinates;

public class ClusterSelector extends ControlAdapter {

    private KMeansCluster kMeans;

    private Visualization dataVis;

    private ParallelCoordinates PC;

    public ClusterSelector(KMeansCluster kMeans, Visualization dataVis,
            ParallelCoordinates PC) {
        this.kMeans = kMeans;
        this.dataVis = dataVis;
        this.PC = PC;

    }

    public void itemPressed(VisualItem cluster, MouseEvent e) {
        if (!SwingUtilities.isLeftMouseButton(e))
            return;


        if (!e.isShiftDown()) {
         //   PC.clearFilters(false);

            Set toSelect = new HashSet();
            List clusterMembers = kMeans.getMembers(cluster.getRow());
            Iterator it = clusterMembers.iterator();
            while (it.hasNext()) {
                VisualItem clusterMember = (VisualItem) it.next();
                if (!clusterMember.getBoolean(ParallelCoordinates.IGNORE) && clusterMember.isVisible()) {
                        toSelect.add(clusterMember);
                }
            }
            PC.setSelectedItems(toSelect);
        } else {
            boolean selectState = !cluster.isHighlighted();

            List toSelect = new ArrayList();
            List clusterMembers = kMeans.getMembers(cluster.getRow());
            Iterator it = clusterMembers.iterator();
            while (it.hasNext()) {
                VisualItem clusterMember = (VisualItem) it.next();
                if (!clusterMember.getBoolean(ParallelCoordinates.IGNORE) && clusterMember.isVisible()) {                    
                    toSelect.add(clusterMember);
                }
            }
            PC.selectInCytoscape(toSelect.toArray(), selectState);

        }
        dataVis.run(ParallelCoordinates.COLOR);

    }

}
