package cerebral.parallelCoordinates.controls;

import java.awt.event.MouseEvent;

import cerebral.parallelCoordinates.YDisplay;

import prefuse.controls.ControlAdapter;
import prefuse.util.ui.UILib;
import prefuse.visual.VisualItem;

public class VerticalPanControl extends ControlAdapter {

    private int yLast;
    private YDisplay yDisplay;

    public VerticalPanControl(YDisplay yDisplay) {
    	this.yDisplay =yDisplay;
    }

    public void mousePressed(MouseEvent e) {
        if (UILib.isButtonPressed(e, MIDDLE_MOUSE_BUTTON)) {
            yLast = e.getY();
        }
    }

    public void mouseDragged(MouseEvent e) {
        if (UILib.isButtonPressed(e, MIDDLE_MOUSE_BUTTON)) {
            int y = e.getY();
            int dy = y - yLast;

            yDisplay.pan(dy);
            yLast = y;
        }
    }

    public void itemPressed(VisualItem item, MouseEvent e) {
        mousePressed(e);
    }

    public void itemDragged(VisualItem item, MouseEvent e) {
        mouseDragged(e);
    }

}
